statelessrule("timer stop", model.Event.BEFORE_FLUSH, function(ctx) {
  return safeCall(ctx.issue,"becomes", ["Timer", find("Stop")], false);
}, function(ctx) {
  if (equals(safeCall(ctx.issue,"getOldValue", ["Timer"]), find("Start"))) {
    var duration = dateMinusDate(now(), safeCall(ctx.issue,"get", ["Timer time"], 0));
    var seconds = (safeCall(duration,"getMillis", [], 0) - safeCall(duration,"getMillis", [], 0) % 1000) / 1000;
    var minutes = (seconds - seconds % 60) / 60;
    var hours = (minutes - minutes % 60) / 60;
    var days = (hours - hours % 24) / 24;
    if (!equals(days, 0)) {
      message(ctx,"Work time: " + days + " days " + hours + " hours " + minutes + " minutes.");
    } else if (!equals(hours, 0)) {
      message(ctx,"Work time: " + hours + " hours " + minutes + " minutes.");
    } else {
      message(ctx,"Work time: " + minutes + " minutes.");
    }
    invoke(ctx, ctx.issue, "applyCommand", ["add work Today " + days + "d" + hours + "h" + minutes + "m" + " The work item automatically added by the timer."]);
  } else {
    message(ctx,"Looks like the timer hasn't been started.\n");
  }
}).addRequirements(requirements([{name: "Issue", fields: [{name: "Timer time", type: {name: "instant", primitive: true}}, {name: "Timer", type: {name: "EnumField", values: ["Start", "Stop"]}}]}]));